Bug 1290576 - Review Request: nodejs-json-schema - JSON Schema specifications, reference schemas, and a CommonJS implementation
Review Request: nodejs-json-schema - JSON Schema specifications, reference sc...
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tom Hughes
Fedora Extras Quality Assurance
:
Depends On:
Blocks: nodejs-reviews 1290577
  Show dependency treegraph
 
Reported: 2015-12-10 15:46 EST by Piotr Popieluch
Modified: 2016-09-28 17:32 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tom: fedora‑review?


Attachments (Terms of Use)

  None (edit)
Description Piotr Popieluch 2015-12-10 15:46:36 EST
Spec URL: https://piotrp.fedorapeople.org/nodejs-json-schema.spec
SRPM URL: https://piotrp.fedorapeople.org/nodejs-json-schema-0.2.2-1.fc23.src.rpm
Description: JSON Schema specifications, reference schemas, and a CommonJS implementation
Fedora Account System Username: piotrp
Comment 1 Tom Hughes 2015-12-10 19:19:51 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "AFL-2.1", "Unknown or generated". 31
     files have unknown license. Detailed output of licensecheck in
     /home/tom/1290576-nodejs-json-schema/licensecheck.txt
[!]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[!]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[!]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-json-schema-0.2.2-1.fc24.noarch.rpm
          nodejs-json-schema-0.2.2-1.fc24.src.rpm
nodejs-json-schema.noarch: W: spelling-error Summary(en_US) schemas -> schema, sachems, schemes
nodejs-json-schema.noarch: W: spelling-error %description -l en_US schemas -> schema, sachems, schemes
nodejs-json-schema.noarch: W: only-non-binary-in-usr-lib
nodejs-json-schema.src: W: spelling-error Summary(en_US) schemas -> schema, sachems, schemes
nodejs-json-schema.src: W: spelling-error %description -l en_US schemas -> schema, sachems, schemes
2 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nodejs-json-schema.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
nodejs-json-schema (rpmlib, GLIBC filtered):
    nodejs(engine)



Provides
--------
nodejs-json-schema:
    nodejs-json-schema
    npm(json-schema)



Source checksums
----------------
https://registry.npmjs.org/json-schema/-/json-schema-0.2.2.tgz :
  CHECKSUM(SHA256) this package     : 41b873a8fb542caf337ec17ad5593761e8db5ce8e33f4074b733b34ec656f0e8
  CHECKSUM(SHA256) upstream package : 41b873a8fb542caf337ec17ad5593761e8db5ce8e33f4074b733b34ec656f0e8
https://raw.githubusercontent.com/dojo/dojo/master/LICENSE :
  CHECKSUM(SHA256) this package     : 645baff64d837b6006fdd933384d9980b754d70f516d2ad696b342ccf118c76b
  CHECKSUM(SHA256) upstream package : 645baff64d837b6006fdd933384d9980b754d70f516d2ad696b342ccf118c76b


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1290576
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 Tom Hughes 2015-12-10 19:21:38 EST
So we need to figure out what the licensing actually is, because package.json says one thing but the comments in the source say something else.

The schemas should be moved in ${_datadir} per guidelines.

Finally, what's going on with the tests? There are some but they don't seem to work as they use an assert.length that no version of node seems to have?
Comment 3 Piotr Popieluch 2015-12-11 02:31:32 EST
This whole module confuses me. Upstream seems to be dead. I'm wondering if it wouldn't be better to patch jsprim to use JSV instead of json-schema. 

There are tests in jsprim which test with JSV. JSV is slower but is already packaged.
See https://github.com/davepacheco/node-jsprim/blob/master/test/validate-bench.js#L1-L15
Comment 4 Tom Hughes 2015-12-11 03:06:54 EST
It doesn't seem very alive, does it, and it's hard to know what license we could specify... I guess "MIT and (AFL or BSD)" or something?!?

As you say, jsprim appears to support both, and patching it would just be changing the "main" entry point in package.json to point at the other file I think?
Comment 5 Piotr Popieluch 2015-12-11 03:32:12 EST
I will try to patch it but have higher priorities at the moment (review of lodash, more missing modules for updating http-signature).
Comment 6 Piotr Popieluch 2016-09-28 17:32:00 EDT
Tom,

I don't expect I will be able to work on this module soon. Not sure if I should close this request or keep it open. 

This is needed for update of http-signature bug: #1179226

Note You need to log in before you can comment on or make changes to this bug.